﻿using System.Reflection;

using Microsoft.Maui.Graphics.Platform;

namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.saveButton.Clicked += saveButton_Clicked;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 이미지 저장하기 버튼 클릭시 처리하기 - saveButton_Clicked(sender, e)

    /// <summary>
    /// 이미지 저장하기 버튼 클릭시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private void saveButton_Clicked(object sender, EventArgs e)
    {
        Microsoft.Maui.Graphics.IImage sourceImage;

        using(Stream sourceStream = Assembly.GetExecutingAssembly().GetManifestResourceStream("TestProject.IMAGE.sample.png"))
        {
            sourceImage = PlatformImage.FromStream(sourceStream);
        }

        string filePath = Path.Combine(FileSystem.CacheDirectory, "sample.png");

        using(FileStream saveStream = new FileStream(filePath, FileMode.Create, FileAccess.Write))
        {
            sourceImage.Save(saveStream);
        }

        using(FileStream loadStream = new FileStream(filePath, FileMode.Open, FileAccess.Read))
        {
            this.image.Source = ImageSource.FromStream(() => loadStream);
        }
    }

    #endregion
}